'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObjectHas = require('lodash/object/has');

var _lodashObjectHas2 = _interopRequireDefault(_lodashObjectHas);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var ItemGroup = (function (_React$Component) {
  _inherits(ItemGroup, _React$Component);

  function ItemGroup(props) {
    _classCallCheck(this, _ItemGroup);

    _get(Object.getPrototypeOf(_ItemGroup.prototype), 'constructor', this).call(this, props);
    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
  }

  _createClass(ItemGroup, [{
    key: 'render',
    value: function render() {
      var _this = this;

      var childCount = _react2['default'].Children.count(this.props.children);
      var children = _react2['default'].Children.map(this.props.children, function (child, idx) {

        var last = idx !== childCount - 1;
        var style = _this.getStyle('itemGroupChild', { last: last }, child.props.style);
        var key = (0, _lodashObjectHas2['default'])(child.props, 'key') ? child.props.key : idx;

        return _react2['default'].cloneElement(child, { style: style, key: key });
      });

      return _react2['default'].createElement(
        'div',
        { style: { display: 'flex' } },
        children
      );
    }
  }]);

  var _ItemGroup = ItemGroup;
  ItemGroup = (0, _utilsMatterBasics2['default'])(ItemGroup) || ItemGroup;
  ItemGroup = (0, _radium2['default'])(ItemGroup) || ItemGroup;
  return ItemGroup;
})(_react2['default'].Component);

exports['default'] = ItemGroup;
module.exports = exports['default'];
//# sourceMappingURL=ItemGroup.js.map