'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ListItem = require('./ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _lodashObjectHas = require('lodash/object/has');

var _lodashObjectHas2 = _interopRequireDefault(_lodashObjectHas);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var List = (function (_React$Component) {
  _inherits(List, _React$Component);

  function List(props) {
    _classCallCheck(this, _List);

    _get(Object.getPrototypeOf(_List.prototype), 'constructor', this).call(this, props);
  }

  _createClass(List, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var mod = _props.mod;
      var style = _props.style;
      var items = _props.items;

      var children;

      if (items) {
        children = items.map(function (item, idx) {
          if (typeof item === 'string') {
            item = { label: item };
          }

          return _react2['default'].createElement(_ListItem2['default'], _extends({}, item, {
            key: (0, _lodashObjectHas2['default'])(item, 'key') ? item.key : idx }));
        });
      } else {
        children = _react2['default'].Children.map(this.props.children, function (child, idx) {
          if ((0, _lodashObjectHas2['default'])(child.props, 'key')) {
            return child;
          } else {
            return _react2['default'].cloneElement(child, { key: idx });
          }
        });
      }

      return _react2['default'].createElement(
        'div',
        _extends({}, this.getBasics(), {
          style: this.getStyle('list', mod, style) }),
        children
      );
    }
  }]);

  var _List = List;
  List = (0, _utilsMatterBasics2['default'])(List) || List;
  List = (0, _radium2['default'])(List) || List;
  return List;
})(_react2['default'].Component);

exports['default'] = List;
module.exports = exports['default'];
//# sourceMappingURL=List.js.map