'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var _utilsFlyer = require('../utils/flyer');

var _utilsFlyer2 = _interopRequireDefault(_utilsFlyer);

var Tooltip = (function (_React$Component) {
  _inherits(Tooltip, _React$Component);

  _createClass(Tooltip, null, [{
    key: 'propTypes',
    value: {
      children: _react2['default'].PropTypes.element.isRequired, //only one child is allowed
      content: _react2['default'].PropTypes.any
    },
    enumerable: true
  }]);

  function Tooltip(props) {
    var _this = this;

    _classCallCheck(this, _Tooltip);

    _get(Object.getPrototypeOf(_Tooltip.prototype), 'constructor', this).call(this, props);

    this.deleayedShow = function () {
      _this.hide();
      _this._showSetT = setTimeout(function () {
        return _this.show();
      }, 500);
    };

    this.hide = function () {
      clearTimeout(_this._showSetT);
      if (_this.disposeLast) {
        _this.disposeLast();
        _this.disposeLast = undefined;
      }
    };

    this.handleMouseMove = function (e) {
      _this.lastX = e.clientX;
      _this.lastY = e.clientY;
      _this.deleayedShow();
    };
  }

  _createClass(Tooltip, [{
    key: 'show',
    value: function show() {
      var _this2 = this;

      this.hide();
      if (this.props.content) {
        this.disposeLast = (0, _utilsFlyer2['default'])({
          x: this.lastX,
          y: this.lastY,
          renderElement: function renderElement() {
            return _this2.renderTooltip();
          },
          wrapperStyle: { pointerEvents: 'none' }
        });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var node = _reactDom2['default'].findDOMNode(this);
      node.addEventListener('mousemove', this.handleMouseMove);
      node.addEventListener('mouseleave', this.hide);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var node = _reactDom2['default'].findDOMNode(this);
      node.removeEventListener('mousemove', this.handleMouseMove);
      node.removeEventListener('mouseleave', this.hide);
      this.hide();
    }
  }, {
    key: 'renderTooltip',
    value: function renderTooltip() {
      return _react2['default'].createElement(
        'div',
        { style: this.getStyle('tooltip') },
        this.props.content
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);

  var _Tooltip = Tooltip;
  Tooltip = (0, _utilsMatterBasics2['default'])(Tooltip) || Tooltip;
  Tooltip = (0, _radium2['default'])(Tooltip) || Tooltip;
  return Tooltip;
})(_react2['default'].Component);

exports['default'] = Tooltip;
module.exports = exports['default'];
//# sourceMappingURL=Tooltip.js.map