'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashObjectHas = require('lodash/object/has');

var _lodashObjectHas2 = _interopRequireDefault(_lodashObjectHas);

exports['default'] = function (theme, mod) {
  var config = theme.getStyle('config', mod);
  var size = (0, _lodashObjectHas2['default'])(mod, 'size') ? mod.size : config.lineHeight;

  return {
    direction: {
      row: {
        height: size
      },
      column: {
        width: size
      }
    },
    flexDirection: mod.direction,
    display: 'flex'
  };
};

module.exports = exports['default'];
//# sourceMappingURL=toolbar.js.map