'use strict';

var React = require('react');
var ReactDOM = require('react-dom');

var ClickAway = React.createClass({
  displayName: 'ClickAway',

  propTypes: {
    children: React.PropTypes.element.isRequired,
    onClickAway: React.PropTypes.func
  },

  componentDidMount: function componentDidMount() {
    this.__mountTimeStamp = Date.now();
    this.__handleClickAway = (function (e) {
      //prevent to catch the same initialiser mouse event when it reaches the document
      if (this.__mountTimeStamp < e.timeStamp) {
        var node = ReactDOM.findDOMNode(this);
        if (!node.contains(e.target) && this.props.onClickAway) {
          this.props.onClickAway();
        }
      }
    }).bind(this);

    document.addEventListener('mousedown', this.__handleClickAway);
    document.addEventListener('contextmenu', this.__handleClickAway);
  },

  componentWillUnmount: function componentWillUnmount() {
    document.removeEventListener('mousedown', this.__handleClickAway);
    document.removeEventListener('contextmenu', this.__handleClickAway);
  },

  render: function render() {
    return this.props.children;
  }
});

module.exports = ClickAway;
//# sourceMappingURL=ClickAway.js.map