'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObjectHas = require('lodash/object/has');

var _lodashObjectHas2 = _interopRequireDefault(_lodashObjectHas);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var Checkbox = (function (_React$Component) {
  _inherits(Checkbox, _React$Component);

  _createClass(Checkbox, null, [{
    key: 'propTypes',
    value: {
      value: _react2['default'].PropTypes.bool,
      disabled: _react2['default'].PropTypes.bool
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      value: false,
      disabled: false
    },
    enumerable: true
  }]);

  function Checkbox(props) {
    _classCallCheck(this, _Checkbox);

    _get(Object.getPrototypeOf(_Checkbox.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    this.state = {
      value: props.value
    };
  }

  _createClass(Checkbox, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {

      this.setState({ value: nextProps.value });
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {

      var value = !this.state.value;

      this.setState({ value: value });

      if (this.props.onChange) {
        this.props.onChange(value);
      }
    }
  }, {
    key: 'renderCheck',
    value: function renderCheck() {

      if (!this.state.value) {
        return null;
      }

      var _getStyle = this.getStyle('config', { gardient: true });

      var start = _getStyle.start;
      var end = _getStyle.end;

      return _react2['default'].createElement(
        'svg',
        { width: "18", height: "18", style: { position: 'absolute' } },
        _react2['default'].createElement(
          'defs',
          null,
          _react2['default'].createElement(
            'linearGradient',
            { id: "grad1", x1: "0%", y1: "0%", x2: "100%", y2: "100%" },
            _react2['default'].createElement('stop', { offset: "0%", style: { stopColor: start, stopOpacity: 1 } }),
            _react2['default'].createElement('stop', { offset: "100%", style: { stopColor: end, stopOpacity: 1 } })
          )
        ),
        _react2['default'].createElement('path', { d: "M3.5 9 L5.5 9 L7.5 11 L12.5 3 L 14.5 3 L8.5 13 L7 13 Z", fill: "url(#grad1)" })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this = this;

      var _props = this.props;
      var mod = _props.mod;
      var style = _props.style;

      return _react2['default'].createElement(
        'div',
        _extends({}, this.getBasics(), {
          style: this.getStyle('checkbox', mod, style),
          onClick: function () {
            return _this.handleClick();
          } }),
        this.renderCheck()
      );
    }
  }]);

  var _Checkbox = Checkbox;
  Checkbox = (0, _utilsMatterBasics2['default'])(Checkbox) || Checkbox;
  Checkbox = (0, _radium2['default'])(Checkbox) || Checkbox;
  return Checkbox;
})(_react2['default'].Component);

exports['default'] = Checkbox;
module.exports = exports['default'];
//# sourceMappingURL=Checkbox.js.map