'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var _lodashArrayFindIndex = require('lodash/array/findIndex');

var _lodashArrayFindIndex2 = _interopRequireDefault(_lodashArrayFindIndex);

var MultiTypeInput = (function (_React$Component) {
  _inherits(MultiTypeInput, _React$Component);

  _createClass(MultiTypeInput, null, [{
    key: 'propTypes',
    value: {},
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      types: []
    },
    enumerable: true
  }]);

  function MultiTypeInput(props) {
    var _this = this;

    _classCallCheck(this, _MultiTypeInput);

    _get(Object.getPrototypeOf(_MultiTypeInput.prototype), 'constructor', this).call(this, props);

    this.handleAddonClick = function () {
      var types = _this.props.types;
      var currentTypeIndex = _this.state.currentTypeIndex;

      currentTypeIndex = (currentTypeIndex + 1) % types.length;
      _this.setState({ currentTypeIndex: currentTypeIndex });
    };

    this.handleChange = function (value) {
      if (_this.props.onChange) {
        _this.props.onChange(value);
      }
    };

    this.state = {
      currentTypeIndex: 0
    };
    this.state.currentTypeIndex = this.getCurrentTypeIndex();
  }

  _createClass(MultiTypeInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ currentTypeIndex: this.getCurrentTypeIndex(nextProps) });
    }
  }, {
    key: 'getCurrentTypeIndex',
    value: function getCurrentTypeIndex(props) {
      props = props || this.props;

      var _props = props;
      var types = _props.types;
      var value = _props.value;
      var currentTypeIndex = this.state.currentTypeIndex;

      function isAccept(type) {
        return !type.acceptValue || type.acceptValue(value);
      }

      if (isAccept(types[currentTypeIndex])) {
        return currentTypeIndex;
      }

      var nextTypeIdx = (0, _lodashArrayFindIndex2['default'])(types, function (type) {
        return isAccept(type);
      });

      if (nextTypeIdx === -1) {
        nextTypeIdx = currentTypeIndex;
      }

      return nextTypeIdx;
    }
  }, {
    key: 'render',
    value: function render() {
      var currentTypeIndex = this.state.currentTypeIndex;

      return _react2['default'].createElement(_Input2['default'], _extends({}, this.getBasics(), this.props, this.props.types[currentTypeIndex], {
        onChange: this.handleChange,
        onInitialFormat: this.handleChange,
        addonOnClick: this.handleAddonClick }));
    }
  }]);

  var _MultiTypeInput = MultiTypeInput;
  MultiTypeInput = (0, _utilsMatterBasics2['default'])(MultiTypeInput) || MultiTypeInput;
  MultiTypeInput = (0, _radium2['default'])(MultiTypeInput) || MultiTypeInput;
  return MultiTypeInput;
})(_react2['default'].Component);

exports['default'] = MultiTypeInput;
module.exports = exports['default'];
//# sourceMappingURL=MultiTypeInput.js.map