'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _Toolbar = require('../Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _ToolbarGroup = require('../ToolbarGroup');

var _ToolbarGroup2 = _interopRequireDefault(_ToolbarGroup);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var AccordionTab = (function (_React$Component) {
  _inherits(AccordionTab, _React$Component);

  function AccordionTab(props) {
    _classCallCheck(this, _AccordionTab);

    _get(Object.getPrototypeOf(_AccordionTab.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    this.state = { opened: true };
  }

  _createClass(AccordionTab, [{
    key: 'onClick',
    value: function onClick() {
      this.setState({ opened: !this.state.opened });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this = this;

      var _props = this.props;

      // var sBase = {}
      // if (this.state.opened) sBase.backgroundColor = style.grey.active
      // else if (this.state.hover) sBase.backgroundColor = style.grey.hover
      // else sBase.backgroundColor = style.grey.normal

      var mod = _props.mod;
      var style = _props.style;
      var sHead = { height: style.lineHeight };

      var content = this.state.opened ? _react2['default'].createElement(
        'div',
        null,
        this.props.children
      ) : '';

      return _react2['default'].createElement(
        'div',
        _extends({}, this.getBrowserStateEvents(), {
          style: this.buildStyles(style.accordionTab, { opened: this.state.opened }),
          onMouseEnter: function () {
            return _this.setState({ hover: true });
          },
          onMouseLeave: function () {
            return _this.setState({ hover: false });
          },
          onMouseDown: function () {
            return _this.setState({ down: true });
          },
          onMouseUp: function () {
            return _this.setState({ down: false });
          } }),
        _react2['default'].createElement(
          _Toolbar2['default'],
          { onClick: this.onClick },
          _react2['default'].createElement(
            _ToolbarGroup2['default'],
            { flex: '1' },
            _react2['default'].createElement(
              _Label2['default'],
              null,
              this.props.label
            )
          ),
          _react2['default'].createElement(_Icon2['default'], {
            icon: this.state.opened ? 'chevron-down' : 'chevron-up',
            style: { color: style.palette.grey4, width: 21 } })
        ),
        content
      );
    }
  }]);

  var _AccordionTab = AccordionTab;
  AccordionTab = (0, _utilsMatterBasics2['default'])(AccordionTab) || AccordionTab;
  AccordionTab = (0, _radium2['default'])(AccordionTab) || AccordionTab;
  return AccordionTab;
})(_react2['default'].Component);

exports['default'] = AccordionTab;
module.exports = exports['default'];
//# sourceMappingURL=AccordionTab.js.map