'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var _lodashObjectAssign = require('lodash/object/assign');

var _lodashObjectAssign2 = _interopRequireDefault(_lodashObjectAssign);

var TabLabel = (function (_React$Component) {
  _inherits(TabLabel, _React$Component);

  _createClass(TabLabel, null, [{
    key: 'propTypes',
    value: {},
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      selected: false
    },
    enumerable: true
  }]);

  function TabLabel(props) {
    _classCallCheck(this, _TabLabel);

    _get(Object.getPrototypeOf(_TabLabel.prototype), 'constructor', this).call(this, props);
    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
  }

  _createClass(TabLabel, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var mod = _props.mod;
      var style = _props.style;

      mod = (0, _lodashObjectAssign2['default'])({
        selected: this.props.selected,
        stretch: this.props.stretch,
        first: this.props.first,
        notFirst: !this.props.first,
        last: this.props.last
      }, mod);

      var icon;
      if (this.props.icon) {
        icon = _react2['default'].createElement(_Icon2['default'], { icon: this.props.icon,
          style: { marginRight: this.props.text ? 4 : 0 } });
      }

      return _react2['default'].createElement(
        'div',
        _extends({}, this.getBasics(), {
          style: this.getStyle('tabLabel', mod, style),
          onClick: this.props.onSelect,
          onDragEnter: this.props.onSelect }),
        icon,
        this.props.label
      );
    }
  }]);

  var _TabLabel = TabLabel;
  TabLabel = (0, _utilsMatterBasics2['default'])(TabLabel) || TabLabel;
  TabLabel = (0, _radium2['default'])(TabLabel) || TabLabel;
  return TabLabel;
})(_react2['default'].Component);

exports['default'] = TabLabel;
module.exports = exports['default'];
//# sourceMappingURL=TabLabel.js.map