'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TabHeader = require('./TabHeader');

var _TabHeader2 = _interopRequireDefault(_TabHeader);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var Tabs = (function (_React$Component) {
  _inherits(Tabs, _React$Component);

  _createClass(Tabs, null, [{
    key: 'propTypes',
    value: {},
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      stretchLabels: true,
      defaultTabIdx: 0,
      currentTabIdx: undefined
    },
    enumerable: true
  }]);

  function Tabs(props) {
    _classCallCheck(this, _Tabs);

    _get(Object.getPrototypeOf(_Tabs.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    this.state = {
      currentTabIdx: props.defaultTabIdx
    };
  }

  _createClass(Tabs, [{
    key: 'handleSelectTab',
    value: function handleSelectTab(idx) {
      this.setState({ currentTabIdx: idx });

      if (this.props.onChangeTabIdx) {

        this.props.onChangeTabIdx(idx);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.currentTabIdx !== undefined) {
        this.setState({ currentTabIdx: nextProps.currentTabIdx });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this = this;

      var _props = this.props;
      var mod = _props.mod;
      var style = _props.style;

      var currentTab;

      _react2['default'].Children.forEach(this.props.children, function (child, idx) {
        if (_this.state.currentTabIdx === idx) {
          currentTab = child;
        }
      });

      return _react2['default'].createElement(
        'div',
        _extends({}, this.getBasics(), {
          style: this.getStyle('tabBase', mod, style) }),
        _react2['default'].createElement(_TabHeader2['default'], {
          currentTabIdx: this.state.currentTabIdx,
          onSelectTab: function (idx) {
            return _this.handleSelectTab(idx);
          },
          children: this.props.children,
          stretchLabels: this.props.stretchLabels }),
        _react2['default'].createElement(
          'div',
          { style: this.getStyle('tabCont', mod) },
          currentTab
        )
      );
    }
  }]);

  var _Tabs = Tabs;
  Tabs = (0, _utilsMatterBasics2['default'])(Tabs) || Tabs;
  Tabs = (0, _radium2['default'])(Tabs) || Tabs;
  return Tabs;
})(_react2['default'].Component);

exports['default'] = Tabs;
module.exports = exports['default'];
//# sourceMappingURL=Tabs.js.map