'use strict';

module.exports = global.Matter = {
  getTheme: require('./theme/getTheme'),
  createTheme: require('./theme/createTheme'),
  defaultTheme: require('./theme/defaultTheme'),

  ClickAway: require('./utils/ClickAway'),
  ContextMenu: require('./utils/ContextMenu'),

  // Accordion: require('./components/accordion/Accordion'),
  // AccordionTab: require('./components/accordion/AccordionTab'),
  Button: require('./components/Button'),
  Checkbox: require('./components/Checkbox'),
  // ColorInput: require('./components/ColorInput'),
  Dropdown: require('./components/Dropdown'),
  // DropdownMenu: require('./components/DropdownMenu'),
  Icon: require('./components/Icon'),
  Input: require('./components/Input'),
  ItemGroup: require('./components/ItemGroup'),
  Label: require('./components/Label'),
  List: require('./components/List'),
  ListItem: require('./components/ListItem'),
  MultiTypeInput: require('./components/MultiTypeInput'),
  Panel: require('./components/Panel'),
  Scrollable: require('./components/scrollable/Scrollable'),
  // Slider: require('./components/Slider'),
  Tabs: require('./components/tabs/Tabs'),
  Toggle: require('./components/Toggle'),
  Toolbar: require('./components/Toolbar'),
  ToolbarGroup: require('./components/ToolbarGroup'),
  Tooltip: require('./components/Tooltip'),
  TooltipHOC: require('./components/TooltipHOC')
};
//# sourceMappingURL=index.js.map