'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = createTheme;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactTheme = require('react-theme');

var _reactTheme2 = _interopRequireDefault(_reactTheme);

var _lodashObjectForOwn = require('lodash/object/forOwn');

var _lodashObjectForOwn2 = _interopRequireDefault(_lodashObjectForOwn);

var _sourceList = require('./sourceList');

var sourceList = _interopRequireWildcard(_sourceList);

function createTheme() {
  var theme = new _reactTheme2['default']();

  (0, _lodashObjectForOwn2['default'])(sourceList, function (styleSrc, name) {
    theme.setSource(name, styleSrc);
  });

  return theme;
}

module.exports = exports['default'];
//# sourceMappingURL=createTheme.js.map