'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = function (theme, mod) {

  var config = theme.getStyle('config', mod);

  var _theme$getStyle = theme.getStyle('toggleConfig', mod);

  var knobWidth = _theme$getStyle.knobWidth;

  var colors = theme.getStyle('colors', mod);

  return {
    mixins: ['font'],

    boxSizing: 'border-box',
    transition: 'left ' + config.anim,
    position: 'relative',
    height: config.lineHeight,
    width: knobWidth,
    display: 'inline-block',
    backgroundColor: colors.grey3,
    onLeft: {
      'true': { left: 0 },
      'false': { left: 'calc(100% - ' + (knobWidth - 2) + 'px)' }
    }
  };
};

module.exports = exports['default'];
//# sourceMappingURL=toggleKnob.js.map